
### Описание предметной области
* Предполагается, что в системе автосалона будет 4 роли пользователей: клиенты, продавцы-консультанты, подборщики, администраторы. Авторизация в системе производится по телефону и паролю. Клиенты могут зарегистрироваться в системе, указав ФИО, телефон, пароль, дату рождения.

* Администраторы – пользователи с уже заполненным профилем. Они могут добавлять новых клиентов и заполнять их заказы. Постоянным клиентам администраторы могут предоставлять скидки на автомобили или на услуги.

* Любой клиент после авторизации может выбрать себе автомобиль. В этом случае клиент видит 3 блока: «Автомобили с пробегом», «Автомобили под заказ», «Продать автомобиль». Клиент может отправить заявку на любой автомобиль или услугу.

* Администратор после авторизации видит новые заявки от клиентов и их количество (если таковые имеются). В случае подтверждения заявки администратор должен позвонить клиенту, уточнить все детали сделки (срок, цена, и т.д.). После обсуждения всех деталей, администратор передает информацию подборщику для дальнейших действий. 

* Также продавцы-консультанты, получившие заказ в самом автосалоне, передают информацию администратору, который регистрирует клиента в базе, а администратор действует по прошлому шаблону. Клиент может узнать информацию о заказе на аккаунте, данные от которого получит от администратора.

* Клиент, отправивший заявку, но не получивший ответа, видит список своих заявок с результатами (в том числе с указанием причины при отказе) и количеством дней ожидания ответа. Получив положительный ответ по заказу, статус заказа меняется с “Ожидание администратора” на “В работе”. Также в блоке заказа имеется информация об автомобиле, примерная дата получения, звонок или чат с подборщиком и кнопка “Отмена заказа”. Для последней функции появляется подтверждение, а далее звонок администратора, который уже сам отменяет заказ. 

* Подборщик также может посмотреть список своих текущих клиентов с указанием у каждого: информация об автомобиле, бюджет (или стоимость автомобиля), примерные сроки. Подборщик может связываться с клиентом (звонок/чат).

* Если клиент выбирает “Продать автомобиль”. Продавец-консультант напрямую получает заявку, даёт примерную оценочную стоимость и приглашает на живую оценку.

### Диаграмма вариантов использования (прецедентов)
![img1](./img/1.png)
![img2](./img/2.png)
![img3](./img/3.png)


### Спецификация вариантов использования (прецедентов)

&nbsp; | &nbsp;
---|------ 
*Имя прецедента* | Прецедент: Выбор услуги
*Идентификатор прецедента* | ID 1
*Краткое описание* | Краткое описание<br/>Покупатель выбирает товар или услугу в автосалоне
*Акторы, вовлеченные в прецедент* | Главные акторы:<br/>Покупатель<br/>Второстепенные акторы:<br/>Администратор, подборщик
*Состояние системы на начало прецедента* | Предусловия:<br/>нет
*Фактические этапы прецедента* | Основной поток:<br/>1. Прецедент начинается, когда Покупатель выбирает товар или услугу<br/>2. Если Покупатель выбирает товар<br/>&nbsp;&nbsp;&nbsp;&nbsp;2.1 Покупатель указывает параметры товара<br/> 3. Если Покупатель выбирает услуги<br/>&nbsp;&nbsp;&nbsp;&nbsp;3.1 Покупатель указывает параметры услуги<br/> 4. Если покупатель выбирает заказ автомобиля<br/>&nbsp;&nbsp;&nbsp;&nbsp;4.1  Администратор связывается с ним<br/>
*Альтернативные потоки* | Альтернативные потоки:<br/>4.1 Администратор связывается с ним
*Состояние системы после окончания прецедента* | Постусловия<br/>1. Покупатель выбрал товар(услугу)<br/>2. Покупатель отказался от покупки 


&nbsp; | &nbsp;
---|------ 
Прецедент | Оформление заказа
Идентификатор | ID 2
Краткое описание | Покупатель оформляет заказ на импортный автомобиль
Главные акторы | Покупатель
Второстепенные акторы | Администратор, подборщик
Предусловия | Покупатель выбрал автомобиль
Основной поток | 1. Прецедент начинается, когда Покупатель выбрал автомобиль<br/>2. Администратор связывается с ним<br/> 3. Уточняются все данные и параметры с обеих сторон<br/> 4. Администратор принимает заказ и передает подборщику
Альтернативные потоки | 2. Подборщик связывается с покупателем
Постусловия | 1. Покупатель сделал заказ.

### Диаграмма состояний

![img21](./img/21.png)
![img22](./img/22.png)
![img23](./img/23.png)

### ER-Диаграмма
![ER-Диаграмма](./img/ER-Диаграмма.png)

### Словарь данных

* Member (Пользователь)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| fullName | varchar(255) | Y | Полное ФИО (строка), обязательное поле
&nbsp;| phoneNumber | varchar(12) | Y | Телефон
&nbsp;| password | varchar(40) | Y | Пароль пользователя
&nbsp;| postAdress | varchar(255) | Y | Адрес доставки
FK | roleId | int | Y | Ссылка на словарь **Role**

* Role (Роль)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(50) | Y | Роль

* Payment (Оплата)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| paymentDate | Date | Y | Дата оплаты
&nbsp;| description | varchar(255) | Y | Описание заказа
&nbsp;| amountPaid | int(15) | Y | Оплаченная сумма

* Order (Заказ автомобиля пользователем)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| transactionDate | Date | Y | Дата транзакции
FK| memberId | int | Y | Ссылка на словарь **Member**
FK| carId | int | Y | Ссылка на словарь **Car**
FK| paymentId | int | Y | Ссылка на словарь **Payment**

* Car (Автомобиль)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
FK| brandId | int | Y | Ссылка на словарь **Brand**
FK| modelId | int | Y | Ссылка на словарь **Model**
FK| generationId | int | Y | Ссылка на словарь **Generation**
&nbsp;| dateOfIssue | Date | Y | Дата выпуска автомобиля
&nbsp;| engineCap | decimal(2,1) |  | Объём двигателя (1-2 знака перед запятой, 1 знак после запятой)
FK| engineId | int | Y | Тип двигателя с ссылкой на словарь **Engine**
&nbsp;| cost | int(15) | Y | Цена автомобиля
FK| colorId | int | Y | Цвет с ссылкой на словарь **Color**
FK| transmissionId | int | Y | Коробка передач с ссылкой на словарь **Transmission**
&nbsp;| photo | varchar(255) |  | Фотография автомобиля (Обязательно, хотя бы 1)
&nbsp;| description | varchar(255) |  | Описание автомобиля
FK| categoryId | int | Y | Категория с ссылкой на словарь **Category** 

* Brand (Марка)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(100) | Y | Марка

* Model (Модель)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(100) | Y | Модель

* Generation (Поколение)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(100) | Y | Поколение

* Engine (Тип двигателя)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(30) | Y | Тип двигателя

* Color (Цвет)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(80) | Y | Цвет

* Transmission (Тип)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(30) | Y | Тип трансмиссии

* Category (Категория)

Key | Field Name | Data Type/Field Size | Required? | Notes
:-:|----|-----|:-:|---
PK | Id | INT | Y |
&nbsp;| titile | varchar(60) | Y | В какой категории продается авто


